﻿Public Class Form1
    'Rodzaj separatora, oddzielającego dane
    Dim separator As String = ","
    'numer kolumny po której posegregujemy dane, zaczynając od 0
    Dim kolumnaSegregacji As Integer = 0
    'jeśli kolumnaSegregacji wymaga przycięcia z lewej lub prawej strony,
    'należy określić wycięcie z lewej i z prawej, w innym wypadku zostawić 
    'zera, wzięcie musi znajdować się w przedziale długości kolumny segregującej
    Dim początekUciecia As Integer = 8
    Dim konicCiecia As Integer = 0
    'zmienna przechowuje pobrane dane
    Private ds As New DataSet()

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'tutaj ustawiamy zachowanie elementów na formie
        ''''''Rozciąganie elementów
        DataGridView2.Anchor = AnchorStyles.Left Or AnchorStyles.Bottom Or AnchorStyles.Top
        DataGridView1.Anchor = AnchorStyles.Left Or AnchorStyles.Bottom Or AnchorStyles.Right
        Wykres.Anchor = AnchorStyles.Left Or AnchorStyles.Bottom Or AnchorStyles.Right Or AnchorStyles.Top
        ''''''Ułożenie legendy na wykresie
        Wykres.Legends(0).Docking = Top
        ''''''Wygląd wykresu
        'więcej elementów na osi X
        Wykres.ChartAreas(0).AxisX.IntervalAutoMode = DataVisualization.Charting.IntervalAutoMode.VariableCount
        'kolor linii
        Wykres.ChartAreas(0).AxisX.MajorGrid.LineColor = Color.Silver
        Wykres.ChartAreas(0).AxisY.MajorGrid.LineColor = Color.Silver
        ''''''Tabela
        DataGridView2.AllowUserToAddRows = False 'użytkownik nie może dodawać wierszy
        DataGridView1.AllowUserToAddRows = False
        'tutaj wprowadzamy ilość kolumn w tabeli analiz
        DataGridView1.ColumnCount = 5
        'tutaj wprowadzamy nazwy kolumn w tabeli analiz
        DataGridView1.Columns(0).Name = "Kolumna odciętych"
        DataGridView1.Columns(1).Name = "Średnia"
        DataGridView1.Columns(2).Name = "Mediana"
        DataGridView1.Columns(3).Name = "Odchylenie standardowe"
        DataGridView1.Columns(4).Name = "Wariancja"

        ''''''Wybieramy lokalizacje danych
        OpenFileDialog1.Filter = "csv, txt files|*.csv;*.txt|All files (*.*)|*.*"
        OpenFileDialog1.Title = "Wybierz źródło danych."
        OpenFileDialog1.FileName = ""
        'jeśli źródło danych zostało wybrane prawidłowo
        With OpenFileDialog1
            If .ShowDialog() = DialogResult.OK Then
                'funkcja zwróci wiersze i kolumny danych do zmiennej DataTable
                Dim myData As DataTable = TworzTabele(.FileName, separator)
                ' dodajemy je do zmiennej DataSet, z której będziemy pobierać dane do obróbki
                ds.Tables.Add(myData)
                'wyświetli podzielone dane w tabeli
                DataGridView2.DataSource = myData
            End If
        End With
        'Segreguje dane wedłóg wskazanej kolumny
        segregacja(kolumnaSegregacji)
    End Sub


    Private Function TworzTabele(ByVal SciezkaDoPliku As String, ByVal separator As String) As DataTable

        Dim Tabela As DataTable = New DataTable("MyTable")
        Dim i As Integer
        Dim wiersze As DataRow
        Dim wartosc As String()
        Dim f As IO.File = Nothing
        Dim rodzajkodu As New IO.StreamReader(SciezkaDoPliku, System.Text.Encoding.UTF8)

        Try
            wartosc = rodzajkodu.ReadLine().Split(separator)

            For i = 0 To wartosc.Length() - 1
                Tabela.Columns.Add(New DataColumn("kolumna" & i))
            Next

            wiersze = Tabela.NewRow
            For i = 0 To wartosc.Length() - 1
                wiersze.Item(i) = wartosc(i).ToString
            Next
            Tabela.Rows.Add(wiersze)
            While rodzajkodu.Peek() <> -1
                wartosc = rodzajkodu.ReadLine().Split(separator)
                wiersze = Tabela.NewRow
                For i = 0 To wartosc.Length() - 1
                    wiersze.Item(i) = wartosc(i).ToString
                Next
                Tabela.Rows.Add(wiersze)
            End While
        Catch ex As Exception
            MsgBox("Błąd przy tworzeniu tabeli: " & ex.Message)
            Return New DataTable("Empty")
        Finally
            rodzajkodu.Close()
        End Try
        Return Tabela
    End Function



    Dim slownik As New Dictionary(Of String, List(Of Double))

    Private Sub segregacja(ByVal kolumnaSegregacji As Integer)

        konicCiecia = ds.Tables.Item(0).Rows(0).Item(kolumnaSegregacji).length - konicCiecia - początekUciecia

        'Przykład różnicowania danych przed wizualizacją
        '''''Przykład dla danych pobranych z MT4
        ' For j As Integer = 0 To 0 'rząd różnicowania
        ' For i As Integer = 1 To ds.Tables.Item(0).Rows.Count - 1
        ' ds.Tables.Item(0).Rows(i).Item(2) = Replace(ds.Tables.Item(0).Rows(i).Item(2), ".", ",") - Replace(ds.Tables.Item(0).Rows(i - 1).Item(2), ".", ",")
        ' ds.Tables.Item(0).Rows(i).Item(3) = Replace(ds.Tables.Item(0).Rows(i).Item(3), ".", ",") - Replace(ds.Tables.Item(0).Rows(i - 1).Item(3), ".", ",")
        ' ds.Tables.Item(0).Rows(i).Item(4) = Replace(ds.Tables.Item(0).Rows(i).Item(4), ".", ",") - Replace(ds.Tables.Item(0).Rows(i - 1).Item(4), ".", ",")
        ' ds.Tables.Item(0).Rows(i).Item(5) = Replace(ds.Tables.Item(0).Rows(i).Item(5), ".", ",") - Replace(ds.Tables.Item(0).Rows(i - 1).Item(5), ".", ",")
        ' Next
        ' ds.Tables.Item(0).Rows(0).Delete()
        ' Next

        'Listujemy wszystkie elementy Dataset
        For i As Integer = 0 To ds.Tables.Item(0).Rows.Count - 1
            Dim sort As String = ds.Tables.Item(0).Rows(i).Item(kolumnaSegregacji).ToString.Substring(początekUciecia, konicCiecia)

            '''''Przykład dla danych pobranych z MT4
            Dim open As Double = Replace(ds.Tables.Item(0).Rows(i).Item(2), ".", ",")
            Dim hight As Double = Replace(ds.Tables.Item(0).Rows(i).Item(3), ".", ",")
            Dim low As Double = Replace(ds.Tables.Item(0).Rows(i).Item(4), ".", ",")
            Dim close As Double = Replace(ds.Tables.Item(0).Rows(i).Item(5), ".", ",")
            '''''''''''''

            'Wykonaj operacje na danych
            Dim wartosc As Double = close - open

            'Dodaj dane do słownika
            If slownik.ContainsKey(sort) = True Then
                slownik(sort).Add(wartosc)
            Else
                'jeśli klucz nie istnieje
                Dim ListaWartosci As New List(Of Double)
                ListaWartosci.Add(wartosc)
                slownik.Add(sort, ListaWartosci)
            End If
        Next

        operacjeNaSlowniku()
    End Sub

    Private Sub operacjeNaSlowniku()
        ' dla każdego klucza w słowniku
        For Each klucze As KeyValuePair(Of String, List(Of Double)) In slownik
            'dodajemy wiersz do tabeli analiz
            DataGridView1.Rows.Add()
            DataGridView1.Rows(DataGridView1.Rows.Count - 1).Cells(0).Value = klucze.Key

            Dim suma As Double = 0

            'Średnia
            Dim srednia As Double = 0
            For i As Integer = 0 To klucze.Value.Count - 1
                suma += klucze.Value(i)
            Next
            srednia = suma / klucze.Value.Count
            DataGridView1.Rows(DataGridView1.Rows.Count - 1).Cells(1).Value = srednia

            'Mediana
            klucze.Value.Sort() 'sortuje listę
            If klucze.Value.Count Mod 2 = 0 Then
                DataGridView1.Rows(DataGridView1.Rows.Count - 1).Cells(2).Value =
                    (klucze.Value(klucze.Value.Count / 2) + klucze.Value((klucze.Value.Count / 2) + 1)) / 2
            Else
                DataGridView1.Rows(DataGridView1.Rows.Count - 1).Cells(2).Value =
                    klucze.Value(Math.Ceiling(klucze.Value.Count / 2))
            End If

            'Odchylenie standardowe
            Dim wariancja As Double = 0
            For i As Integer = 0 To klucze.Value.Count - 1
                wariancja += (klucze.Value(i) - srednia) ^ 2
            Next
            wariancja = wariancja / klucze.Value.Count
            DataGridView1.Rows(DataGridView1.Rows.Count - 1).Cells(3).Value = Math.Sqrt(wariancja)

            'Wariancja
            DataGridView1.Rows(DataGridView1.Rows.Count - 1).Cells(4).Value = wariancja
        Next
        TworzenieWykresu()
    End Sub

    Private Sub TworzenieWykresu()

        Wykres.ChartAreas(0).AxisY.LabelStyle.Format = "N2"
        Wykres.Series.Clear()
        Dim min As Double = Double.MaxValue
        Dim max As Double = Double.MinValue

        'średnie
        Wykres.Series.Add(0)
        Wykres.Series(0).Name = "Średnia"
        Wykres.Series(0).Color = Color.FromArgb(128, 128, 255)
        Wykres.Series(0).BorderWidth = 2
        Wykres.Series(0).ChartType = DataVisualization.Charting.SeriesChartType.Line
        For i As Integer = 0 To DataGridView1.Rows.Count - 1
            Dim srednia As Double = DataGridView1.Rows(i).Cells(1).Value
            Wykres.Series(0).Points.AddXY(DataGridView1.Rows(i).Cells(0).Value, srednia)
        Next
        'Mediana
        Wykres.Series.Add(1)
        Wykres.Series(1).Name = "Mediana"
        Wykres.Series(1).Color = Color.Tomato
        Wykres.Series(1).BorderWidth = 2
        Wykres.Series(1).ChartType = DataVisualization.Charting.SeriesChartType.Line
        For i As Integer = 0 To DataGridView1.Rows.Count - 1
            Dim Mediana As Double = DataGridView1.Rows(i).Cells(2).Value
            Wykres.Series(1).Points.AddXY(DataGridView1.Rows(i).Cells(0).Value, Mediana)
        Next

        'odchylenie standardowe
        '     Wykres.Series.Add(2)
        '    Wykres.Series(2).Name = "Odchylenie standardowe"
        '    Wykres.Series(2).Color = Color.Orange
        '    Wykres.Series(2).BorderWidth = 2
        '     Wykres.Series(2).ChartType = DataVisualization.Charting.SeriesChartType.StepLine
        '     For i As Integer = 0 To DataGridView1.Rows.Count - 1
        '     Dim SDK As Double = DataGridView1.Rows(i).Cells(3).Value
        '     Wykres.Series(2).Points.AddXY(DataGridView1.Rows(i).Cells(0).Value, SDK)
        '     Next

        'Wartości najwyzsze
        '   Wykres.Series.Add(3)
        '   Wykres.Series(3).Name = "Najwyższe"
        '   Wykres.Series(3).Color = Color.Green
        '   Wykres.Series(3).BorderWidth = 2
        '   Wykres.Series(3).ChartType = DataVisualization.Charting.SeriesChartType.Column

        '        For i As Integer = 0 To DataGridView1.Rows.Count - 1
        '        Dim najwyzszy As Double = slownik(DataGridView1.Rows(i).Cells(0).Value).Item(0)
        '        For j As Integer = 0 To slownik(DataGridView1.Rows(i).Cells(0).Value).Count - 1
        '        If najwyzszy < slownik(DataGridView1.Rows(i).Cells(0).Value).Item(j) Then
        '        najwyzszy = slownik(DataGridView1.Rows(i).Cells(0).Value).Item(j)
        '        End If
        '        Next
        '        Wykres.Series(3).Points.AddXY(DataGridView1.Rows(i).Cells(0).Value, najwyzszy)
        '        Next

        'Wartości najniższe
        '   Wykres.Series.Add(4)
        '   Wykres.Series(4).Name = "Najniższe"
        '   Wykres.Series(4).Color = Color.Red
        '   Wykres.Series(4).BorderWidth = 2
        '   Wykres.Series(4).ChartType = DataVisualization.Charting.SeriesChartType.Column
        '
        'For i As Integer = 0 To DataGridView1.Rows.Count - 1
        'Dim najnizszy As Double = slownik(DataGridView1.Rows(i).Cells(0).Value).Item(0)
        'For j As Integer = 0 To slownik(DataGridView1.Rows(i).Cells(0).Value).Count - 1
        'If najnizszy > slownik(DataGridView1.Rows(i).Cells(0).Value).Item(j) Then
        'najnizszy = slownik(DataGridView1.Rows(i).Cells(0).Value).Item(j)
        'End If
        'Next
        'Wykres.Series(4).Points.AddXY(DataGridView1.Rows(i).Cells(0).Value, najnizszy)
        'Next

        For i As Integer = 0 To Wykres.Series.Count - 1
            If Wykres.Series(i).Enabled Then
                For j As Integer = 0 To Wykres.Series(i).Points.Count - 1
                    Dim value As Double = Wykres.Series(i).Points(j).YValues(0)
                    If value < min Then min = value
                    If value > max Then max = value
                Next
            End If
        Next

        Wykres.ChartAreas(0).AxisY.Minimum = min
        Wykres.ChartAreas(0).AxisY.Maximum = max
    End Sub

    Private Sub DataGridView1_ColumnHeaderMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DataGridView1.ColumnHeaderMouseClick
        TworzenieWykresu()
    End Sub
End Class
